#<: 'logging.pl' v0.001 @ 2012-09-26 18:04:33 UTC :>#

use strict;
use Sys::Syslog;
use Text::CSV;

my %lov = (''=>0,' '=>1);
my $logopen = '';
my $logstdout = 0;
my $logstderr = 1;
sub init_log {
	my ($program,$logorder) = @_;
	unless ($logopen eq $program) {
		closelog() if ($logopen);
		openlog($program,'nowait,pid','daemon');
		$SIG{'__DIE__'} = sub {
			my @msg = map { $_ =~ s/^\s+//; $_ =~ s/\s+$//; ($_ eq '') ? () : $_; } split(/\s*[\r\n]+\s*/,join("\n",@_));
			foreach my $msg (@msg) {
				syslog('err', '%s', $msg);
			}
        	die(@_);
    	};
		$SIG{'__WARN__'} = sub {
			my @msg = map { $_ =~ s/^\s+//; $_ =~ s/\s+$//; ($_ eq '') ? () : $_; } split(/\s*[\r\n]+\s*/,join("\n",@_));
			foreach my $msg (@msg) {
				syslog('warning', '%s', $msg);
			}
        	warn(@_);
    	};
	}
	%lov = (''=>0,' '=>1);
	if ($logorder) {
		for (my $i=0;$i<length($logorder);$i++) {
  			$lov{substr($logorder,$i,1)} = $i+1;
		}
		$lov{' '} = length($logorder)+1;
	}
	return 1;
}

my $ssv = Text::CSV->new({sep_char=>';',quote_char=>'"',escape_char=>'"',quote_space=>0});
my $csv = Text::CSV->new({sep_char=>',',quote_char=>"'",escape_char=>"'",quote_space=>0});
sub loginf {
	my %req = @_;
	my @log = ();
	#$req{'#'} = time();
	#$req{''} = time2str('%Y-%m-%d %H:%M:%S',$req{'#'});
	foreach my $k (keys %req) {
		next unless (ref($req{$k}) eq 'HASH');
		my $rr = 0;
		foreach my $kk (keys %{$req{$k}}) {
			next unless (ref($req{$k}->{$kk}));
			$rr ++;
			last;
		}
		next unless ($rr);
		foreach my $kk (keys %{$req{$k}}) {
			$req{"$k$kk"} = $req{$k}->{$kk};
		}
		delete $req{$k};
	}
	foreach my $k (sort {	my $a1 = substr($a,0,1);
							my $b1 = substr($b,0,1);
							$a1 = sprintf('%02u%s',(defined($lov{$a1}) ? $lov{$a1} : $lov{' '}),$a);
							$b1 = sprintf('%02u%s',(defined($lov{$b1}) ? $lov{$b1} : $lov{' '}),$b);
							$a1 cmp $b1 } keys %req) {
		if (ref($req{$k}) eq 'HASH') {
			next unless (%{$req{$k}});
			$req{$k} = [map { join(':',$_,$req{$k}->{$_}) } keys %{$req{$k}}];
		}
		if (ref($req{$k}) eq 'ARRAY') {
			next unless (@{$req{$k}});
			$req{$k} = $csv->combine(@{$req{$k}}) ? $csv->string : join(',',@{$req{$k}});
		}
		next unless (defined($req{$k}) && $req{$k} ne '');
		push @log, ($k =~ /[a-zA-Z0-9]/) ? "$k=$req{$k}" : "$k$req{$k}";
	}
	return undef unless (@log);
	unshift @log, '{DEBUG}' if ($debug);
	my $log = $ssv->combine(@log) ? $ssv->string : join(';',@log);
	syslog('notice','%s',$log);
	print STDOUT "$log\n" if ($logstdout);
	return 0;
}

sub logerr {
	my $log = join(': ','Error',join('; ',(map { ($_ eq '') ? () : $_ } @_)));
	syslog('err','%s',$log);
	$log = "{DEBUG} $log" if ($debug);
	print STDERR "$log\n" if ($logstderr);
	return 0;
}

init_log('','');
