sub dnssec_sign_rrs {
	my $key = shift @_;
	my $zone = shift @_;
	return undef unless (@_);
	my @key = dnssec_find_keys($zone,$key);
	return undef unless (@key);
	mkdir("$cfg->{''}->{datadir}/:temp") unless (-d "$cfg->{''}->{datadir}/:temp");
	my $f = undef;
	open($f,'>',"$cfg->{''}->{datadir}/:temp/wtdnssign.$$.rrl");
	print $f join("\n",@_,'');
	close($f);
	system('ldns-signzone','-f',"$cfg->{''}->{datadir}/:temp/wtdnssign.$$.rrs","$cfg->{''}->{datadir}/:temp/wtdnssign.$$.rrl",@key);
	unlink("$cfg->{''}->{datadir}/:temp/wtdnssign.$$.rrl");
	$f = undef;
	my @rrs = ();
	open($f,'<',"$cfg->{''}->{datadir}/:temp/wtdnssign.$$.rrs");
	while (my $l = <$f>) {
print "$l\n";
		next unless ($l =~ /^(\S+?)\.\s+(\d+)\s+IN\s+(RRSIG|DNSKEY|NSEC|NSEC3)\s+(.*?)[\s\r\n]*$/);
		my %rr = (n=>$1,l=>$2,t=>$3,d=>$4);
		if ($rr{t} eq 'RRSIG') {
			next unless ($rr{d} =~ /^(\S+)\s+(.*?)$/);
			$rr{o} = $1;
			$rr{d} = $2;
		}
		push @rrs, \%rr;
	}
	close($f);
	unlink("$cfg->{''}->{datadir}/:temp/wtdnssign.$$.rrs");
	return wantarray ? @rrs : \@rrs;
}

sub dnssec_sign_names {
	my $key = shift @_;
	my $zone = undef;
	my %names = ();
	foreach my $name (map { lc($_) } @_) {
		next if (exists $names{$name});
		print "Fetching: $name\n";
		$names{$name} = undef;
		my $qres = query_daemon('ANY',$name);
		next unless ($qres);
		$names{$name} = [];
		foreach my $qans ($qres->authority) {
			next unless ($qans->type eq 'SOA');
			$zone = $qans->name	if ((length($qans->name) > 1) && !(defined($zone) && (length($qans->name) > length($zone))));
			push @{$names{$name}}, $qans->string;
		}
		foreach my $qans ($qres->answer) {
			push @{$names{$name}}, $qans->string;
		}
	}
	return dnssec_sign_rrs($key,$zone,map { $_ ? @{$_} : () } values %names);
}

sub dnssec_sign_zone {
	my $key = shift @_;
	my %zones = ();
	my %names = ();
	foreach my $zone (map { lc($_) } @_) {
		next if (exists $zones{$zone});
		print "Listing: $zone\n";
		$zones{$zone} = undef;
		my $zqres = query_daemon('PTR',"*.$zone");
		next unless ($zqres);
		$zones{$zone} = 0;
		foreach my $zqans ($zqres->answer) {
			next unless ($zqans->type eq 'PTR');
			my $name = lc($zqans->ptrdname);
			next if (exists $names{$name});
			print "Fetching: $name\n";
			$names{$name} = undef;
			my $nqres = query_daemon('ANY',$name);
			next unless ($nqres);
			$names{$name} = [];
			foreach my $qans ($nqres->answer) {
				push @{$names{$name}}, $qans->string;
				$zones{$zone} ++;
			}
		}
	}
	my @zones = sort { (length($a) <=> length($b)) || ($zones{$a} <=> $zones{$b}) || ($a cmp $b) } map { $zones{$_} ? $_ : () } keys %zones;
	return dnssec_sign_rrs($key,$zones[0],map { $_ ? @{$_} : () } values %names);
}

