#<: 'update.pl' v0.003 @ 2012-10-07 00:19:14 UTC (Jonas@Ubbe-III) "Jonas Eckerman" <jonas@truls.org> :>#

use File::Temp qw(tempfile);
use File::Copy;
use File::Path qw(make_path);

sub update_record {
	my ($host,$type,$data,$dir,@dir) = @_;
	($dir,@dir) = $host ? host_dir($host) : ($cfg->{''}->{datadir},$cfg->{''}->{datadir}) unless ($dir);
	my $file = "$dir/$type";
	my $ok = '+';
	if (open(F,'<',$file)) {
		my $curd = join('',<F>);
		close(F);
		my $ok = '%';
		$curd =~ s/[\r\n]+$/\n/;
		if ($curd eq $data) {
			unless ($debug) {
				my $now = time();
				eval { chmod(0755,@dir); };
				eval { chmod(0644,$file); };
				eval { utime($now,$now,$file); };
			}
			return ('=',$file) if (-e $file);
		}
	}
	return ($ok,$file) if ($debug);
	eval { chmod(0755,@dir); };
	unless (-d $dir) {
		eval { make_path($dir,{mode=>0755}) };
		if ($@) {
			$@ =~ s/[\r\n]+$//s;
			$@ =~ s/ at \S+ line \d+$//;
			return ('mp',$@);
		}
	}
	my $temp = join(':','',$type,$$,'XXXXX');
	my ($th,$tf) = (undef,undef);
	eval { ($th,$tf) = tempfile("$dir/$temp",UNLINK=>0); };
	if ($@) {
		$@ =~ s/[\r\n]+$//s;
		$@ =~ s/ at \S+ line \d+$//;
		return ('tc',$@);
	}
	return ('tf',"tempfile '$dir/$temp' error!") unless ($th && $tf);
	eval { chmod(0644,$tf); };
	print $th $data;
	unless (close($th)) {
		unlink($tf);
		return ('tw',"tempfile '$tf' error!");
	}
	unlink("$file;RRSIG") if (-e "$file;RRSIG");
	unless (move($tf,$file)) {
		unlink($tf);
		return ('mf',"move ('$tf' -> '$file') error: $!");
	}
	eval { chmod(0755,@dir); };
	eval { chmod(0644,$file); };
	return ($ok,$file);
}
