#!/usr/bin/perl
#<: 'wtdns-deepen.pl' v0.004 @ 2012-09-26 18:03:43 UTC :>#

our $VERSION = '0.004';

use strict;
use File::Path qw(make_path);

require 'config.pl';
unless ($hasher) {
	print STDERR "${dbgp}Need hasher!\n";
	exit(1);
}

unless (opendir(D,$cfg->{''}->{datadir})) {
	print STDERR "${dbgp}Error opening data dir: $cfg->{''}->{datadir}\n";
	exit(1);
}
my @ddirs = ();
while (my $f = readdir(D)) {
	next if ($f =~ /^\./);
	next if ($f =~ /^#[0-9A-F][0-9A-F]$/);
	next unless (-d "$cfg->{''}->{datadir}/$f");
	push @ddirs, $f;
}
closedir(D);

my $er = 0;
while (@ddirs) {
	my $d = shift @ddirs;
	my $he = 0;
	unless (open(F,"$hasher '$d'|")) {
		print STDERR "${dbgp}wtdnshash error: $d\n";
		exit(3);
	}
	my $hd = <F>;
	close(F);
	unless ($hd =~ /^(#?[0-9A-F][0-9A-F])[\r\n]*$/s) {
		print STDERR "${dbgp}wtdnshash error: $hasher $d ($hd)\n";
		exit(3);
	}
	$hd = $1;
	unless (-d "$cfg->{''}->{datadir}/$hd") {
		eval { make_path("$cfg->{''}->{datadir}/$hd",{mode=>0755}) };
		unless (-d "$cfg->{''}->{datadir}/$hd") {
			print STDERR "${dbgp}Error creating hash dir: $hd\n";
			$er ++;
			next;
		}
	}
	unless (-e "$cfg->{''}->{datadir}/$hd/$d") {
		unless ($debug) {
			if (!rename("$cfg->{''}->{datadir}/$d","$cfg->{''}->{datadir}/$hd/$d")) {
				print STDERR "${dbgp}Error renaming: $d -> $hd/$d\n";
				$he ++;
				$er ++;
			}
		}
		unless ($he) {
			print STDOUT "${dbgp}$d -> $hd/$d\n";
			next;
		}
	}
	unless (opendir(D,"$cfg->{''}->{datadir}/$d")) {
		print STDERR "${dbgp}Error opening host dir: $d\n";
		$er ++;
		next;
	}
	my @rfils = ();
	while (my $f = readdir(D)) {
		next if ($f =~ /^\./);
		push @rfils, $f;
	}
	closedir(D);
	while (@rfils) {
		my $f = shift @rfils;
		unless ($debug) {
			unless (rename("$cfg->{''}->{datadir}/$d/$f","$cfg->{''}->{datadir}/$hd/$d/$f")) {
				print STDERR "${dbgp}Error renaming: $d/$f -> $hd/$d/$f\n";
				$he ++;
				$er ++;
				next;
			}
		}
		print STDOUT "${dbgp}$d/$f -> $hd/$d/$f\n";
	}
	unless ($debug) {
		rmdir("$cfg->{''}->{datadir}/$d");
		if (-e "$cfg->{''}->{datadir}/$d") {
			print STDERR "${dbgp}Error removing host dir: $hd/$d\n" unless ($he);
			$he ++;
			$er ++;
		}
	}
	print STDOUT "${dbgp}$d -> $hd/$d\n" unless ($he);
}

exit(2) if ($er);
