#!/usr/bin/perl
#<: 'wtdns-flatten.pl' v0.003 @ 2012-09-26 18:03:34 UTC :>#

our $VERSION = '0.003';

use strict;

require 'config.pl';

unless (opendir(D,$cfg->{''}->{datadir})) {
	print STDERR "${dbgp}Error opening data dir: $cfg->{''}->{datadir}\n";
	exit(1);
}
my @hdirs = ();
while (my $f = readdir(D)) {
	next if ($f =~ /^\./);
	next unless ($f =~ /^#?[0-9A-F][0-9A-F]$/);
	next unless (-d "$cfg->{''}->{datadir}/$f");
	push @hdirs, $f;
}
closedir(D);

my $er = 0;
while (@hdirs) {
	my $he = 0;
	my $hd = shift @hdirs;
	unless (opendir(D,"$cfg->{''}->{datadir}/$hd")) {
		print STDERR "${dbgp}Error opening hash dir: $hd\n";
		$er ++;
		next;
	}
	my @rdirs = ();
	my @mdirs = ();
	while (my $f = readdir(D)) {
		next if ($f =~ /^\./);
		next unless (-d "$cfg->{''}->{datadir}/$hd/$f");
		if (-d "$cfg->{''}->{datadir}/$f") {
			push @mdirs, $f;
		} elsif (-e "$cfg->{''}->{datadir}/$f") {
			print STDERR "${dbgp}Conflict: $hd/$f\n";
			$er ++;
			$he ++;
		} else {
			push @rdirs, $f;
		}
	}
	closedir(D);
	push @mdirs, '';
	while (@rdirs) {
		my $d = shift @rdirs;
		unless ($debug) {
			unless (rename("$cfg->{''}->{datadir}/$hd/$d","$cfg->{''}->{datadir}/$d")) {
				print STDERR "${dbgp}Error renaming: $hd/$d -> $d\n";
				push @mdirs, $d;
				$er ++;
				$he ++;
				next;
			}
		}
		print STDOUT "${dbgp}$hd/$d -> $d\n";
	}
	my $pe = 0;
	while (@mdirs) {
		my $d = shift @mdirs;
		if ($d eq '') {
			$pe ++;
			next;
		}
		my $de = 0;
		unless (-d "$cfg->{''}->{datadir}/$d") {
			eval { make_path("$cfg->{''}->{datadir}/$d",{mode=>0755}) };
			unless (-d "$cfg->{''}->{datadir}/$d") {
				print STDERR "${dbgp}Error creating host dir: $d\n" unless ($pe);
				$er ++;
				$he ++;
				next;
			}
		}
		unless (opendir(D,"$cfg->{''}->{datadir}/$hd/$d")) {
			print STDERR "${dbgp}Error opening host dir: $hd/$d\n" unless ($pe);
			$er ++;
			$he ++;
			next;
		}
		my @rfils = ();
		while (my $f = readdir(D)) {
			next if ($f =~ /^\./);
			push @rfils, $f;
		}
		closedir(D);
		while (@rfils) {
			my $f = shift @rfils;
			if (-e "$cfg->{''}->{datadir}/$hd/$d/$f") {
				print STDERR "${dbgp}Conflict: $hd/$d/$f\n";
				$er ++;
				$de ++;
				$he ++;
				next;
			}
			unless ($debug) {
				unless (rename("$cfg->{''}->{datadir}/$hd/$d/$f","$cfg->{''}->{datadir}/$d/$f")) {
					print STDERR "${dbgp}Error renaming: $hd/$d/$f -> $d/$f\n";
					$er ++;
					$de ++;
					$he ++;
					next;
				}
			}
			print STDOUT "${dbgp}$hd/$d/$f -> $d/$f\n";
		}
		unless ($debug) {
			rmdir("$cfg->{''}->{datadir}/$hd/$d");
			if (-e "$cfg->{''}->{datadir}/$hd/$d") {
				print STDERR "${dbgp}Error removing host dir: $hd/$d\n" unless ($de || $pe);
				$er ++;
				$he ++;
			}
		}
	}
	unless ($debug) {
		rmdir("$cfg->{''}->{datadir}/$hd");
		if (-e "$cfg->{''}->{datadir}/$hd") {
			print STDERR "${dbgp}Error removing hash dir: $hd\n" unless ($he);
			$er ++;
		}
	}
}

exit(2) if ($er);
