//<: 'dir.h' v0.029 @ 2012-10-08 19:08:22 UTC (Jonas@Ubbe-III) "Jonas Eckerman" <jonas@truls.org> :>//

/* What the DNS global directory functions */

// get hash for string
char *hex_hash(unsigned char *s);
// get all hashes
char **hex_hashes(int type);

// Get directory for domain name
int get_dir_path (char *buf, int len, char *name);
// Get file path for query
int get_file_path (char *buf, int len, char *name, char *type);

// Descend tree looking ofr match:
#define DCL_DESCEND 0x01
// Remember what was found:
#define DCL_MEMORY  0x02
// Check if domain directory exists
int directory_check(int qtype, unsigned char *name, int flags);
// Find and read resource records
char **directory_lookup(int qtype, unsigned char *name, int flags);
// Read resource records related to the last found one
char **related_lookup(int baseqtype, int relqtype, unsigned char *name);
// Lookup domains and subdomains:
char **names_lookup(int qtype, unsigned char *query);

// Include psudo domains (strange characters in names) in searches:
#define SDH_INC_PSEUDO 0x01
// Exclude domains (list only hosts/subdomains) in searches:
#define SDH_EXC_DOMAIN 0x02
// Search for domain and subdomains in hash directories:
int search_for_hosts_in_domain(char **buf, int *bsz, char **hosts, char **first, char **last, int hfllen, char *domain, int flags);

// Get modification time
//struct tm *get_mtime(int qtype, unsigned char *name);

// Get modification time for last found file
struct tm *get_found_mtime();

// Actual name for last found record:
extern char found_name[MAX_RECORD_LEN + 1];
// Labels cut of from name to find it:
extern int found_cuts;
// Saved time of last found record:
extern time_t found_mtime;
// Saved record type of last found record:
extern int found_qtype;

// Create a directory
void make_directory(char *dir, char* desc);
// Create a file and write contents to it
void make_file(char *dir, char *type, char *data, char *desc);
