//<: 'global.h' v0.011 @ 2012-10-08 18:55:34 UTC (Jonas@Ubbe-III) "Jonas Eckerman" <jonas@truls.org> :>//

/* What the DNS global definitions and settings */

#include <pwd.h>
#include <grp.h>

//What am I and how can I be used?
extern char *program;
extern char *versionstring;
extern char *usagestring;

// Hash types
#define HASH_NEW	0
#define HASH_NO		1
#define HASH_OLD	2

typedef unsigned char u1;
typedef unsigned short u2;
typedef unsigned int u4;

// What hash type should we use?
extern int hash_type;

// Where do we keep resource records?
extern char *data_dir;

// Use DNSSEC?
extern int dsec_on;
// Are we assured that our data is authentic?
extern int dsec_auth;
// Are we assured that our dynamic data is authentic?
extern int dsec_ddns_auth;

// Do we care of ddns timeouts?
extern int ddns_timeouts;
// What base domain if we care?
extern char *ddns_domain;
// Do we care of ddns record files user and group?
extern int ddns_usergroup;
// What user if we care?
extern uid_t ddns_user;
// What group if we care?
extern gid_t ddns_group;
// Records older than how many seconds should not be served?
extern unsigned int ddns_purge;
// Records older than how many seconds should be replaced with fallback if exists?
extern unsigned int ddns_fallback;

// Check standard command line boolean options
int global_arg_option(char *opt);
// Check standard command line settings
int global_arg_setting(char *opt, char *val);

// Read and parse configuration file
int read_config(char *file);

// Free and null global variables
void free_globals();

// Get uid for name of default
uid_t get_user_id(char *name, uid_t dusr);

// Get fid for name of default
gid_t get_group_id(char *name, gid_t dgrp);

// Free global variables
void free_globals();

// Get fallback record for type
char *ddns_fallback_record(int type);

// Get check if host is in dynamic DNS domain
int ddns_domain_cmp(char *name);

#define max(a,b) ((a) > (b) ? (a) : (b))
#define min(a,b) ((a) < (b) ? (a) : (b))
#define freen(x) do { if (x) { free(x); x = NULL; }} while (0)
