//<: 'knobs.h' v0.011 @ 2012-10-08 22:18:58 UTC (Jonas@Ubbe-III) "Jonas Eckerman" <jonas@truls.org> :>//

/* What the DNS global options */


/* File and directory settings */

// Main resource data default directory:
#define DATA_DIR	"/var/lib/wtdns"
// Main configuration file:
#define INI_FILE	"/etc/wtdns/wtdns.ini"
// Create mode for directories:
#define NEW_DIR_MODE	0755
// Create mode for files:
#define NEW_FILE_MODE	0644


/* Size limits */

// Max size read from RR file:
#define MAX_RECORD_LEN	1024

// UDP response message max size when not using EDNS (RFC1035 says 512):
#define MAX_UDP         512
// Max size for incoming messages, and for outgoing UDP messages when using EDNS:
#define MAX_MSG         1280
// Max size for outgoing UDP messages when using DNSSEC:
#define MAX_SEC         4096
// Max size for outgoing TCP messages:
#define MAX_TCP         4096
// Max size for outgoing messages on control sockets when using EDNS:
#define MAX_CTL         4096
// Buffer to use for incoming and outgoing messages (must have margin):
#define MAX_BUF         5120


/* Features */

// Support TXT RR macros:
#define MACROS          1
// Log counters every n seconds:
#define COUNTER_LOG     3600


/* TCP Connection settings */

// Maximum simultaneous connections:
#define MAX_CONNECTIONS 1024
// Max time before a connection is forced close:
#define MAX_CONN_TIME   600
// Max time sending or receiving one message may take:
#define MAX_IO_TIME     60
// Max idle time before a connection is forced close for inactivity:
#define MAX_IDLE_TIME   30
// Use TCP keepalive:
#define TCP_KEEPALIVE   1
// Use non blocking TCP input:
// Max size of single TCP block when sending:
#define MAX_IO_BLOCK    8192


/* System adaptations */

// Use "clock_gettime" function for very high precision times in logs
#define LOG_TIME_CLOCK_GETTIME  0
// Use "gettimeofday" function for high precision times in logs
#define LOG_TIME_GETTIMEOFDAY   1
// Use "time" function for low precision times in logs
#define LOG_TIME_TIME           1

/* Default times */

#define TEN_MINUTES	(10 * 60)
#define ONE_DAY		(24 * 60 * 60)
#define THREE_DAYS	(3 * 24 * 60 * 60)

// the following values are meaningless, since they all apply to secondary DNS servers, and we are not using them:
#define REFRESH		(TEN_MINUTES)
#define RETRY		(TEN_MINUTES)
#define EXPIRE		(THREE_DAYS)

/* Debugging stuff... */

#include "makestamp.h"
#define MEMWATCH 1
#if MAKEMEMW
#include "memwatch.h"
#endif

