//<: 'sockutil.h' v0.009 @ 2012-10-01 10:54:09 UTC (Jonas@Ubbe-III) "Jonas Eckerman" <jonas@truls.org> :>//

/* What the DNS IP socket stuff */

#include <sys/socket.h>

#include "knobs.h"

typedef struct {
  int fd;
  int dgcn;
  int ipv;
  int conn;
  char type[4];
} ip_socket;

#define sock_open(s)    (s && (s->fd != -1))
#define sock_ipv4(s)    (s && (s->ipv == AF_INET))
#define sock_ipv6(s)    (s && (s->ipv == AF_INET6))

#define sock_close(s)   do { if (s && (s->fd != -1)) { if (s->conn) shutdown(s->fd,SHUT_RDWR); close(s->fd); s->fd = -1; }} while (0)

#define sock_free(s)    do { if (s) { sock_close(s); free(s); s = NULL; }} while (0);

int sock_listen(ip_socket **socks, int *sockcnt, char *address, char *service);
int sock_listen_random(ip_socket **socks, int *count, int *port);
ip_socket *sock_accept(ip_socket *srvsock);

int sock_send(ip_socket *sock, u1 *buf, int sz, int block);
int sock_receive(ip_socket *sock, u1 *buf, int sz, int block);

int sock_send_to(ip_socket *sock, u1 *buf, int sz);
int sock_receive_from(ip_socket *srvsock, u1 *buf, int sz);

char *sock_address_string(ip_socket *sock);
char *sock_service_string(ip_socket *sock);
char *sock_local_address_string(ip_socket *sock);

char *address_string(struct sockaddr *from, int fromlen);
char *my_domain_name();

