//<: 'strutil.h' v0.018 @ 2012-10-08 19:14:00 UTC (Jonas@Ubbe-III) "Jonas Eckerman" <jonas@truls.org> :>//

/* What the DNS string stuff */

#include <time.h>

void string_clean_text (unsigned char *p);
void string_clean_resource (unsigned char *s);
void string_chomp (unsigned char *s);
void lower_case_name(unsigned char *n);
void upper_case_name(unsigned char *n);

unsigned int parse_duration(char *s);

char **string_split(char *in, char c, int maxrec, int maxbuf, int maxline);
int string_present (char *s, char **a);

int format_duration(char *buf, int len, int secs);
int format_time_since(char *buf, int len, time_t then);

int random_name(char *buf, int len);
int sub_of_domain(char *name, char *domain);

char *next_token(char *tokens, int *index, char delim);
u4 next_number(char *str, int *index, int max);
char *host_info();

#define bad_name_char(c)					\
	(!(							\
		   ((c) >= 'a' && (c) <= 'z')			\
		|| ((c) >= 'A' && (c) <= 'Z')			\
		|| ((c) >= '0' && (c) <= '9')			\
		||  (c) == '.'					\
		||  (c) == '-'					\
	))

#define bad_text_char(c)                                        \
        ((c) < ' ' || (c) > '~')

#define bad_resource_char(c)					\
	(!(							\
		   ((c) >= 'a' && (c) <= 'z')			\
		|| ((c) >= 'A' && (c) <= 'Z')			\
		|| ((c) >= '0' && (c) <= '9')			\
		||  (c) == '.' || (c) == '-'			\
		||  (c) == '[' || (c) == ']'			\
		||  (c) == '{' || (c) == '}'			\
		||  (c) == '"' || (c) == '\''	                \
		||  (c) == ':' || (c) == ';'			\
		||  (c) == '@' || (c) == '\\'		        \
		||  (c) == '+' || (c) == '/'			\
		||  (c) == '=' || (c) == '%'			\
		||  (c) == '!' || (c) == '~'			\
		||  (c) == ','          			\
	))

#define bad_db_name_char(c)					\
	(!(							\
		   ((c) >= 'a' && (c) <= 'z')			\
		|| ((c) >= '0' && (c) <= '9')			\
		||  (c) == '.'					\
		||  (c) == '-'					\
	))

#define bad_db_name_first_char(c)				\
	(!(							\
		   ((c) >= 'a' && (c) <= 'z')			\
		|| ((c) >= '0' && (c) <= '9')			\
	))
