//<: 'wtdnshash.c' v0.007 @ 2012-09-26 18:35:29 UTC :>//

/* What the DNS hash command */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "knobs.h"
#include "dir.h"
#include "global.h"
#include "version.h"

// standalone program main
int main (int argc, char **argv) 
{
  program = HPROGRAM;
  versionstring = HVERSIONSTRING;
  usagestring = HUSAGESTRING;

  if (argc < 1)
  {
    fprintf(stderr, "%s\n", usagestring);
    exit(1);
  }
  read_config(INI_FILE);
  char buf[1024];
  int k;
  char *s;
  for (k = 1; k < argc; k++)
  {
    if (global_arg_option(argv[k]))
      continue;
    if ((k < argc - 1) && global_arg_setting(argv[k], argv[k+1]))
    {
      k++;
      continue;
    }
    if (argv[k][0] == '-')
    {
      fprintf(stderr, "%s\n", usagestring);
      exit(1);
    }
    mkdir(data_dir, NEW_DIR_MODE);
    switch(hash_type)
    {
      case HASH_NO:
        s = "";
        snprintf(buf, sizeof (buf), "%s/%s", data_dir, argv[k]);
        break;
      default:
        s = hex_hash((unsigned char *)argv[k]);
        snprintf(buf, sizeof (buf), "%s/%s", data_dir, s);
        mkdir(buf, NEW_DIR_MODE);
        snprintf(buf, sizeof (buf), "%s/%s/%s", data_dir, s, argv[k]);
    }
    mkdir(buf, NEW_DIR_MODE);
    fprintf(stdout,"%s\n",s);
  }
  return 0;
}
